/**
 * Używamy właśnej funkcji generującej unikalnego hasha.
 *
 * @TODO Przenieść poza adapter, żeby nie trzeba było duplikować kodu
 */
function code_gen(length, special) {
  var iteration = 0;
  var password = "";
  var randomNumber;
  if(special == undefined){
      var special = false;
  }
  while(iteration < length){
    randomNumber = (Math.floor((Math.random() * 100)) % 94) + 33;
    if(!special){
      if ((randomNumber >=33) && (randomNumber <=47)) { continue; }
      if ((randomNumber >=58) && (randomNumber <=64)) { continue; }
      if ((randomNumber >=91) && (randomNumber <=96)) { continue; }
      if ((randomNumber >=123) && (randomNumber <=126)) { continue; }
    }
    iteration++;
    password += String.fromCharCode(randomNumber);
  }
  return password;
}
/* ------------ */


/**
 * Backbone localStorage Adapter
 * https://github.com/jeromegn/Backbone.localStorage
 */

(function() {
// A simple module to replace `Backbone.sync` with *localStorage*-based
// persistence. Models are given GUIDS, and saved into a JSON object. Simple
// as that.

// Generate four random hex digits.
function S4() {
   return (((1+Math.random())*0x10000)|0).toString(16).substring(1);
};

// Generate a pseudo-GUID by concatenating random hexadecimal.
function guid() {
   return (S4()+S4()+"-"+S4()+"-"+S4()+"-"+S4()+"-"+S4()+S4()+S4());
};


// Our Store is represented by a single JS object in *localStorage*. Create it
// with a meaningful name, like the name you'd give a table.
// window.Store is deprectated, use Backbone.LocalStorage instead
Backbone.LocalStorage = window.Store = function(name) {
  this.name = name;
  var store = this.localStorage().getItem(this.name);
  this.records = (store && store.split(",")) || [];
};

/**
 * Adapter od WebSQL działa tak, że kolekcja podpinamy go poprzez:
 *
 * store: new WebSQLStore(db, 'collection_name')
 *
 * Zatem, żeby zamiast WebSQL można było użyć innych adapterów, to
 * też tworzymy konstruktor o takiej nazwie.
 */
window.db = null // inaczej niż w przypadku WebSQL, nie mamy w localStorage połączenia z bazą
window.WebSQLStore = function(db, name) {
    return new Backbone.LocalStorage(name)
}
/* ------------ */

_.extend(Backbone.LocalStorage.prototype, {

  type: 'localStorage',

  // Save the current state of the **Store** to *localStorage*.
  save: function() {
    this.localStorage().setItem(this.name, this.records.join(","));
  },

  // Add a model, giving it a (hopefully)-unique GUID, if it doesn't already
  // have an id of it's own.
  create: function(model) {
    /**
     * Każdy nowy element modelu musi mieć wygenerowany
     * unikalny id oraz nadaną flagę "is_new: true",
     * aby, po wysłaniu przez sync do serwera, mógł być odpowiednio
     * potraktowany,
     */
    if (!model.id) {
      model.id = model.attributes.id = code_gen(16);
      model.attributes.is_new = true;
    }
    /* ------------ */
    this.localStorage().setItem(this.name+"-"+model.id, JSON.stringify(model));
    this.records.push(model.id.toString());
    this.save();
  },

  // Update a model by replacing its copy in `this.data`.
  update: function(model) {
    this.localStorage().setItem(this.name+"-"+model.id, JSON.stringify(model));
    if (!_.include(this.records, model.id.toString()))
      this.records.push(model.id.toString());
    this.save();
    // nie zwracamy wartości, aby Backbone nie chciał ponownie zapisywać danych
    // szczegóły w backbone.js L483 (v 1.1.2)
  },

  // Retrieve a model from `this.data` by id.
  find: function(model) {
    var it = this.localStorage().getItem(this.name+"-"+model.id);
    return it ? JSON.parse(it) : '';
  },

  // Return the array of all models currently in storage.
  findAll: function() {
    return _(this.records).chain()
        .map(function(id){
            var it = this.localStorage().getItem(this.name+"-"+id);
            return it ? JSON.parse(it) : '';
        }, this)
        .compact()
        .value();
  },

  // Delete a model from `this.data`, returning it.
  destroy: function(model) {
    this.localStorage().removeItem(this.name+"-"+model.id);
    this.records = _.reject(this.records, function(record_id){return record_id == model.id.toString();});
    this.save();
    return model;
  },

  /* added */
  destroyAll: function (success, error, options) {
      var ids = (this.localStorage().getItem(this.name)||'').split(',')
      for (var i = 0, length = ids.length; i < length; i++) {
          this.localStorage().removeItem(this.name+"-"+ids[i])
      }
      this.records = []
      this.localStorage().removeItem(this.name)
      success && success()
  },
  /* ------------ */

  localStorage: function() {
      return localStorage;
  },


  /**
   * W WebSQL dodane zostały transakcje, aby masowe inserty/update'y
   * były wywoływane zbiorczo (wydajność!)
   *
   * LocalStorage tego nie używa, ale trzeba wystawić "puste" funkcje,
   * aby interfejs był kompatybilny.
   */
  beginTransaction: function() {

  },

  commitTransaction: function(success) {
     if (success) success();
  }
  /* ------------ */

});

// localSync delegate to the model or collection's
// *localStorage* property, which should be an instance of `Store`.
// window.Store.sync and Backbone.localSync is deprectated, use Backbone.LocalStorage.sync instead
Backbone.LocalStorage.sync = window.Store.sync = Backbone.localSync = function(method, model, options, error) {

  // Backwards compatibility with Backbone <= 0.3.3
  if (typeof options == 'function') {
    options = {
      success: options,
      error: error
    };
  }

  var resp;
  var store = model.store || model.collection.store;

  /**
   * LocalStorage ma ograniczoną pojemność, więc przechwytujemy wyjątki
   * przy operacja zapisu, które prawdopodobnie oznaczają przekroczoną quotę.
   */
  try {
      switch (method) {
          case "read":    resp = model.id != undefined ? store.find(model) : store.findAll(); break;
          case "create":  resp = store.create(model);                            break;
          case "update":  resp = store.update(model);                            break;
          case "delete":  resp = store.destroy(model);                           break;
      }
      options.success(resp);
      return
  }
  catch (e) {
      // data wasn't successfully saved, probably due to quota exceed
      console.log(e)
  }
  /* ------------ */
  options.error("Record not found");
};

/* added (not used any longer?) */
Backbone.clearStorage = function(success) {
    localStorage.clear();
    if (success) success();
}
/* ------------ */

// Override 'Backbone.sync' to default to localSync,
// the original 'Backbone.sync' is still available in 'Backbone.ajaxSync'
Backbone.ajaxSync = Backbone.sync;
Backbone.sync = Backbone.LocalStorage.sync;

/**
 * Wystawiamy globalną zmienną nozLocalStorage. To do niej odwołuje się
 * App.Config, aby zapisywać ustawienia aplikacji.
 */
window.nozLocalStorage = localStorage
/* ------------ */

})();
